package de.thpeetz.kontor.tysc.views;

import java.util.List;

import com.vaadin.flow.component.ComponentEvent;
import com.vaadin.flow.component.ComponentEventListener;
import com.vaadin.flow.component.Key;
import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.component.button.ButtonVariant;
import com.vaadin.flow.component.formlayout.FormLayout;
import com.vaadin.flow.component.grid.Grid;
import com.vaadin.flow.component.orderedlayout.HorizontalLayout;
import com.vaadin.flow.component.textfield.TextField;
import com.vaadin.flow.data.binder.BeanValidationBinder;
import com.vaadin.flow.data.binder.Binder;

import de.thpeetz.kontor.tysc.data.Vendor;
import de.thpeetz.kontor.tysc.data.CardSet;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class VendorForm extends FormLayout {

    TextField name = new TextField("Name");
    Grid<CardSet> cardSets = new Grid<>(CardSet.class);

    Button save = new Button("Save");
    Button delete = new Button("Delete");
    Button close = new Button("Cancel");

    Binder<Vendor> binder = new BeanValidationBinder<>(Vendor.class);

    public VendorForm() {
        addClassName("vendor-form");
        binder.bindInstanceFields(this);

        cardSets.setColumns("name", "parallelSet");
        cardSets.getColumns().forEach(col -> col.setAutoWidth(true));
        add(name, cardSets, createButtonsLayout());
    }

    private HorizontalLayout createButtonsLayout() {
        save.addThemeVariants(ButtonVariant.LUMO_PRIMARY);
        delete.addThemeVariants(ButtonVariant.LUMO_ERROR);
        close.addThemeVariants(ButtonVariant.LUMO_TERTIARY);

        save.addClickShortcut(Key.ENTER);
        close.addClickShortcut(Key.ESCAPE);

        save.addClickListener(event -> validateAndSave());
        delete.addClickListener(event -> fireEvent(new DeleteEvent(this, binder.getBean())));
        close.addClickListener(event -> fireEvent(new CloseEvent(this)));

        binder.addStatusChangeListener(e -> save.setEnabled(binder.isValid()));
        return new HorizontalLayout(save, delete, close);
    }

    private void validateAndSave() {
        if (binder.isValid()) {
            fireEvent(new SaveEvent(this, binder.getBean()));
        }
    }

    public void setVendor(Vendor vendor) {
        binder.setBean(vendor);
    }

    public void setCardSets(List<CardSet> sets) {
        log.info("Setting card sets: {}", sets);
        this.cardSets.setItems(sets);
    }

    public abstract static class VendorFormEvent extends ComponentEvent<VendorForm> {
        private Vendor vendor;

        protected VendorFormEvent(VendorForm source, Vendor vendor) {
            super(source, false);
            this.vendor = vendor;
        }

        public Vendor getVendor() {
            return vendor;
        }
    }

    public static class SaveEvent extends VendorFormEvent {
        SaveEvent(VendorForm source, Vendor vendor) {
            super(source, vendor);
        }
    }

    public static class DeleteEvent extends VendorFormEvent {
        DeleteEvent(VendorForm source, Vendor vendor) {
            super(source, vendor);
        }
    }

    public static class CloseEvent extends VendorFormEvent {
        CloseEvent(VendorForm source) {
            super(source, null);
        }
    }

    public void addDeleteListener(ComponentEventListener<DeleteEvent> listener) {
        addListener(DeleteEvent.class, listener);
    }

    public void addSaveListener(ComponentEventListener<SaveEvent> listener) {
        addListener(SaveEvent.class, listener);
    }

    public void addCloseListener(ComponentEventListener<CloseEvent> listener) {
        addListener(CloseEvent.class, listener);
    }
}
